__INT_CMDS = {
    'zebra': [
        {
            "period": "30",
            "key": "zebra-ping",
            "command": "/usr/bin/vtysh -d zebra -c quit",
        }
    ],
    'bgpd': [
        {
            "period": "15",
            "key": "bgp-neighbors",
            "command": ["/usr/bin/vtysh", "-c",
                        "show ip bgp vrf all neighbors json"],
            "callback": bgp.process_bgp_neighbors
        },
        {
            "period": "15",
            "key": "evpn-vni",
            "command": ["/usr/bin/vtysh", "-c",
                        "show bgp l2vpn evpn vni json"],
            "callback": bgp.process_bgp_evpn_vni,
        },
    ],
    'ospfd': [
        {
            "period": "15",
            "key": "ospf-neighbor-json",
            "command": ["/usr/bin/vtysh", "-c",
                        "show ip ospf neighbor detail json"],
            "callback": ospf.process_ospf_neighbors
        },
        {
            "period": "15",
            "key": "ospf-interface-json",
            "command": ["/usr/bin/vtysh", "-c",
                        "show ip ospf interface json"],
            "callback": ospf.process_ospf_if
        }

    ],
    'clagd': [
        {
            "period": "15",
            "key": "clagctl-json",
            "command": "/usr/bin/clagctl -j",
            "callback": clag.process_clagctl
        }
    ],
    'mstpd': [
        {
            "period": "15",
            "key": "mstpctl-bridge-json",
            "command": "/sbin/mstpctl showall json",
            "callback": mstp.process_mstpall
        }
    ],
    "misc": [
        {
            "period": "30",
            "key": "cl-license",
            "command": "/usr/sbin/switchd -lic",
            "callback": license.process_cl_license
        },
        {
            "period": "30",
            "key": "ports",
            "command": None,
            "callback": ports.process_ports
        },
        {
            "period": "15",
            "key": "proc-net-dev",
            "command": None,
            "callback": proc.process_proc_net_dev,
        },
    ],
    "lldpd": [
        {
            "period": "30",
            "key": "lldp-neighbor-json",
            "command": "/usr/sbin/lldpctl -f json",
            "callback": lldpd.process_lldpctl
        }
    ],
    "smond": [
        {
            "period": "30",
            "key": "smonctl-json",
            "command": "/usr/sbin/smonctl -j",
            "callback": sensors.process_sensors
        }
    ],
    "vxrd": [
        {
            "period": "15",
            "key": "vxrd-show-json",
            "command": "/usr/bin/vxrdctl -j show",
            "callback": lnv.process_vxrdctl_show
        },
        {
            "period": "15",
            "key": "vxrd-peers-json",
            "command": "/usr/bin/vxrdctl -j peers",
            "callback": lnv.process_vxrdctl_peers
        }
    ],
    "vxsnd": [
        {
            "period": "15",
            "key": "vxsnd-show-json",
            "command": "/usr/bin/vxsndctl -j show",
            "callback": lnv.process_vxsndctl_show
        },
        {
            "period": "15",
            "key": "vxsnd-fdb-json",
            "command": "/usr/bin/vxsndctl -j fdb",
            "callback": lnv.process_vxsndctl_fdb
        },
        {
            "period": "15",
            "key": "vxsnd-config-json",
            "command": "/usr/bin/vxsndctl -j get config",
            "callback": lnv.process_vxsndctl_get_config
        }
    ]
}
